## fcitx 4.2.9.9

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.6)

project(fcitx)

set(version 4.2.9.9)

set(CMAKE_C_STANDARD 99)
set(CMAKE_C_STANDARD_REQUIRED TRUE)

find_package(ECM 0.0.11 REQUIRED NO_MODULE)
set(CMAKE_MODULE_PATH "${ECM_MODULE_PATH}" "${CMAKE_CURRENT_SOURCE_DIR}/cmake" ${CMAKE_MODULE_PATH})
set(CMAKE_AUTOMOC_RELAXED_MODE TRUE)

set_property(GLOBAL PROPERTY "__FCITX_INTERNAL_BUILD" On)

option(ENABLE_X11 "Enable X11 as dependency" ON)
option(ENABLE_GLIB2 "Enable GLib2 as depenedency" ON)
option(ENABLE_CAIRO "Enable Cairo" ON)
option(ENABLE_DBUS "Enable DBus Support" ON)
option(ENABLE_PANGO "Enable Pango Support" ON)
option(ENABLE_XKB "Enable xkb support" ON)
option(ENABLE_DEBUG "Enable Debug" OFF)
option(ENABLE_PINYIN "Enable Pinyin" ON)
option(ENABLE_TABLE "Enable Table IM" ON)
option(ENABLE_GTK2_IM_MODULE "Enable GTK2 IM Module" ON)
option(ENABLE_GTK3_IM_MODULE "Enable GTK3 IM Module" OFF)
option(ENABLE_QT "Enable Qt-based lib" On)
option(ENABLE_QT_IM_MODULE "Enable Qt IM Module" ON)
option(ENABLE_QT_GUI "Enable Qt-based configuration GUI" On)
option(ENABLE_OPENCC "Enable OpenCC for Chinese Transform" ON)
option(FORCE_OPENCC
  "Enable opencc even if the library is not found at compile time" Off)
option(ENABLE_LUA "Enable Lua support" OFF)
option(ENABLE_STATIC "Build Static Library" OFF)
option(ENABLE_TEST "Test build" OFF)
option(ENABLE_SNOOPER "Enable Key Snooper for gtk app" On)
option(ENABLE_GIR "Enable GObject Introspection" On)
option(ENABLE_ENCHANT "Enable enchant for word predication" On)
option(ENABLE_PRESAGE "Enable presage for word predication" On)
option(FORCE_ENCHANT
  "Enable enchant even if the library is not found at compile time" Off)
option(FORCE_PRESAGE
  "Enable presage even if the library is not found at compile time" Off)
option(ENABLE_BACKTRACE "Enable backtrace support" On)
option(ENABLE_XDGAUTOSTART "Enable xdg autostart desktop file installation" On)
option(ENABLE_GETTEXT "Enable gettext support." On)
option(ENABLE_SPELL "Enable Spell Addon" On)

if(NOT NO_SNOOPER_APPS)
  set(NO_SNOOPER_APPS ".*chrome.*,.*chromium.*,firefox.*,Do.*"
    CACHE STRING "Disable Key Snooper for following app")
endif()

if(NOT NO_PREEDIT_APPS)
  set(NO_PREEDIT_APPS "gvim"
    CACHE STRING "Disable Preedit for the following apps")
endif()

include(CheckIncludeFiles)
include(CheckFunctionExists)
include(FindPkgConfig)
include(UseDoxygen OPTIONAL)
include(FcitxMacro)

_fcitx_add_uninstall_target()
check_include_files(unistd.h HAVE_UNISTD_H)
check_include_files(malloc.h HAVE_MALLOC_H)
check_include_files(stdbool.h HAVE_STDBOOL_H)
check_function_exists(asprintf HAVE_ASPRINTF)

find_package(Libintl REQUIRED)
find_package(Libiconv REQUIRED)
find_package(Pthread REQUIRED)
find_package(Libexecinfo)
find_package(GettextPo)
find_package(XKBCommon 0.5.0 REQUIRED COMPONENTS XKBCommon)

if(NOT ENABLE_GETTEXT OR NOT GETTEXTPO_FOUND)
  fcitx_disable_gettext()
endif()

if(LIBEXECINFO_LIB_FOUND)
  set(ENABLE_BACKTRACE 1)
else()
  set(ENABLE_BACKTRACE 0)
endif()

if(${CMAKE_SYSTEM_NAME} MATCHES "BSD")
  find_package(Libkvm REQUIRED)
endif(${CMAKE_SYSTEM_NAME} MATCHES "BSD")
find_package(DL REQUIRED)
if(ENABLE_ENCHANT)
  find_package(Enchant)
  if(NOT (ENCHANT_FOUND OR FORCE_ENCHANT))
    set(ENABLE_ENCHANT Off)
  endif()
endif()
if (ENABLE_XKB)
    # Parse xkb xml file
    find_package(LibXml2 REQUIRED)
    find_package(IsoCodes REQUIRED)
    find_package(XkbFile REQUIRED)
    # Parse isocodes json
    pkg_check_modules(JsonC "json-c" IMPORTED_TARGET REQUIRED)
endif (ENABLE_XKB)
if(ENABLE_PRESAGE)
  find_package(Presage)
  if(NOT (PRESAGE_FOUND OR FORCE_PRESAGE))
    set(ENABLE_PRESAGE Off)
  endif()
endif()

if(ENABLE_QT)
  find_package(Qt4 4.8 COMPONENTS QtCore QtGui QtDBus REQUIRED)
endif()

if(ENABLE_X11)
find_package(X11 REQUIRED)

if (NOT X11_Xkb_FOUND)
    message(FATAL_ERROR "Xkb is needed")
endif (NOT X11_Xkb_FOUND)

find_package(XKeyboardConfig REQUIRED)

endif()

if (ENABLE_TEST)
    enable_testing()
endif ()

set(_ENABLE_CAIRO 0)
set(_ENABLE_PANGO 0)
if (ENABLE_X11 AND ENABLE_CAIRO)
    PKG_CHECK_MODULES(CAIRO_XLIB REQUIRED "cairo-xlib>=1.0" )
    if (CAIRO_XLIB_FOUND)
        set(_ENABLE_CAIRO 1)
    endif (CAIRO_XLIB_FOUND)
endif (ENABLE_X11 AND ENABLE_CAIRO)

set(_ENABLE_PANGO 0)
if (_ENABLE_CAIRO AND ENABLE_GLIB2)
    if (ENABLE_PANGO)
        PKG_CHECK_MODULES(PANGOCAIRO "pangocairo>=1.0" )
        if (PANGOCAIRO_FOUND)
            set(_ENABLE_PANGO 1)
        endif (PANGOCAIRO_FOUND)
    endif (ENABLE_PANGO)
    if (NOT _ENABLE_PANGO)
        PKG_CHECK_MODULES(FONTCONFIG REQUIRED "fontconfig")
    endif (NOT _ENABLE_PANGO)
endif(_ENABLE_CAIRO AND ENABLE_GLIB2)

set(_ENABLE_DBUS 0)
if (ENABLE_DBUS)
    PKG_CHECK_MODULES(DBUS "dbus-1>=1.1.0" )
    if (DBUS_FOUND)
        set(_ENABLE_DBUS 1)
    endif (DBUS_FOUND)
endif (ENABLE_DBUS)

if(ENABLE_OPENCC)
    find_package(OpenCC)
    if(NOT (OPENCC_FOUND OR FORCE_OPENCC))
        set(ENABLE_OPENCC Off)
    endif()
endif()

set(HAVE_XINERAMA 0)
if (X11_Xinerama_FOUND)
    set(HAVE_XINERAMA 1)
endif (X11_Xinerama_FOUND)

if (X11_Xfixes_FOUND)
    set(HAVE_XFIXES 1)
endif (X11_Xfixes_FOUND)

if(ENABLE_DEBUG)
    set(_DEBUG ON)
endif(ENABLE_DEBUG)

set(package     fcitx)
set(prefix      ${CMAKE_INSTALL_PREFIX})
set(exec_prefix ${CMAKE_INSTALL_PREFIX})
set(bindir ${exec_prefix}/bin)

if(NOT DEFINED LIB_INSTALL_DIR)
    set(LIB_INSTALL_DIR "${exec_prefix}/lib" CACHE PATH "Library install directory [default=PREFIX/lib/]")
endif()
if(NOT DEFINED LIBDATA_INSTALL_DIR)
    set(LIBDATA_INSTALL_DIR "${LIB_INSTALL_DIR}"  CACHE PATH "Lib data install directory [default=LIB_INSTALL_DIR]")
endif()
if(NOT DEFINED MAN_INSTALL_DIR)
    set(MAN_INSTALL_DIR "${prefix}/share/man"  CACHE PATH "man install directory [default=PREFIX/share/man]")
endif()
if (NOT DEFINED DBUS_SERVICE_DIR)
    set(DBUS_SERVICE_DIR "${CMAKE_INSTALL_PREFIX}/share/dbus-1/services" CACHE PATH "dbus session service directory [default=PREFIX/share/dbus-1/services]")
endif()
if (NOT DEFINED SYSCONFDIR)
    set(SYSCONFDIR "${CMAKE_INSTALL_PREFIX}/etc" CACHE PATH "sys config directory [default=PREFIX/etc/]")
endif()

set(includedir "${CMAKE_INSTALL_PREFIX}/include")
set(libdir ${LIB_INSTALL_DIR})
set(pkgconfdir ${LIBDATA_INSTALL_DIR}/pkgconfig)
set(mandir ${MAN_INSTALL_DIR})
set(addondir ${libdir}/${package} )
set(pkgdatadir ${prefix}/share/${package})
set(configdescdir ${pkgdatadir}/configdesc)
set(addonconfigdir ${pkgdatadir}/addon)
set(imconfigdir ${pkgdatadir}/inputmethod)
set(localedir ${CMAKE_INSTALL_PREFIX}/share/locale)

list(FIND CMAKE_PLATFORM_IMPLICIT_LINK_DIRECTORIES "${LIB_INSTALL_DIR}" _isSystemPlatformLibDir)
list(FIND CMAKE_CXX_IMPLICIT_LINK_DIRECTORIES "${LIB_INSTALL_DIR}" _isSystemCxxLibDir)
if("${_isSystemPlatformLibDir}" STREQUAL "-1" AND "${_isSystemCxxLibDir}" STREQUAL "-1")
    set(CMAKE_SKIP_BUILD_RPATH  FALSE)
    set(CMAKE_BUILD_WITH_INSTALL_RPATH FALSE)
    set(CMAKE_INSTALL_RPATH "${LIB_INSTALL_DIR}")
    set(CMAKE_INSTALL_RPATH_USE_LINK_PATH TRUE)
endif("${_isSystemPlatformLibDir}" STREQUAL "-1" AND "${_isSystemCxxLibDir}" STREQUAL "-1")

# For FcitxMacro
set(FCITX4_ADDON_INSTALL_DIR ${addondir})
set(FCITX4_CONFIGDESC_INSTALL_DIR ${configdescdir})
set(FCITX4_ADDON_CONFIG_INSTALL_DIR ${addonconfigdir})
set(FCITX4_INPUTMETHOD_CONFIG_INSTALL_DIR ${imconfigdir})
set(FCITX4_PACKAGE_NAME ${package})

function(_RESOLVE_LIBRARY_PATH _FILE_NAME _LIBRARY_PATH)
    if (CMAKE_OBJDUMP)
        execute_process (
            COMMAND ${CMAKE_OBJDUMP} -p "${_LIBRARY_PATH}"
            RESULT_VARIABLE STATUS
            OUTPUT_VARIABLE OBJDUMP_RESULT
            ERROR_QUIET
        )
        string(REGEX REPLACE ".*SONAME +([^ ]+)\n.*$" "\\1" SONAME_OUT "${OBJDUMP_RESULT}")
        if (SONAME_OUT)
            set(_FILE_NAME_OUT "${SONAME_OUT}")
        endif ()
    endif()
    if (NOT _FILE_NAME_OUT)
        get_filename_component(_FILE_NAME_OUT "${_LIBRARY_PATH}" NAME)
    endif()
    set(${_FILE_NAME} ${_FILE_NAME_OUT} PARENT_SCOPE)
endfunction()


if (NOT DEFINED OPENCC_LIBRARY_FILENAME)
    if (OPENCC_LIBRARIES)
        _RESOLVE_LIBRARY_PATH(OPENCC_LIBRARY_FILENAME "${OPENCC_LIBRARIES}")
    else ()
        set(OPENCC_LIBRARY_FILENAME
            "${CMAKE_SHARED_LIBRARY_PREFIX}opencc${CMAKE_SHARED_LIBRARY_SUFFIX}")
    endif ()
endif()

if(NOT DEFINED ENCHANT_LIBRARY_FILENAME)
    if (ENCHANT_LIBRARIES)
        _RESOLVE_LIBRARY_PATH(ENCHANT_LIBRARY_FILENAME "${ENCHANT_LIBRARIES}")
    else ()
        set(ENCHANT_LIBRARY_FILENAME
            "${CMAKE_SHARED_LIBRARY_PREFIX}enchant${CMAKE_SHARED_LIBRARY_SUFFIX}")
    endif ()
endif()
if(NOT DEFINED PRESAGE_LIBRARY_FILENAME)
    if (PRESAGE_LIBRARIES)
        _RESOLVE_LIBRARY_PATH(PRESAGE_LIBRARY_FILENAME "${PRESAGE_LIBRARIES}")
    else ()
        set(PRESAGE_LIBRARY_FILENAME
            "${CMAKE_SHARED_LIBRARY_PREFIX}presage${CMAKE_SHARED_LIBRARY_SUFFIX}")
    endif ()
endif()

set(CMAKE_C_FLAGS "-Wall -Wextra -Wno-sign-compare -Wno-unused-parameter -fvisibility=hidden ${CMAKE_C_FLAGS}")
set(CMAKE_CXX_FLAGS "-Wall -Wextra -Wno-sign-compare -Wno-unused-parameter -fvisibility=hidden ${CMAKE_CXX_FLAGS}")
set(CMAKE_SHARED_LINKER_FLAGS "-Wl,--as-needed ${CMAKE_SHARED_LINKER_FLAGS}")
set(CMAKE_MODULE_LINKER_FLAGS "-Wl,--as-needed ${CMAKE_MODULE_LINKER_FLAGS}")
add_definitions("-D_GNU_SOURCE -DFCITX_HAVE_CONFIG_H")

configure_file(${PROJECT_SOURCE_DIR}/config.h.in ${PROJECT_BINARY_DIR}/config.h)
configure_file("${PROJECT_SOURCE_DIR}/cmake/FcitxConfigVersion.cmake.in"
               "${PROJECT_BINARY_DIR}/cmake/FcitxConfigVersion.cmake"
                IMMEDIATE @ONLY
)

include_directories(${PROJECT_BINARY_DIR})
include_directories(${PROJECT_BINARY_DIR}/src/)
include_directories(${PROJECT_SOURCE_DIR}/src/)
include_directories(${PROJECT_SOURCE_DIR}/src/lib/)

# must be the first
add_subdirectory(po)
add_subdirectory(src)
add_subdirectory(doc)
add_subdirectory(skin)
add_subdirectory(tools)
add_subdirectory(data)
add_subdirectory(cmake)

if(ENABLE_TEST)
  add_subdirectory(test)
endif()

=== cmake/CMakeLists.txt ===
install(FILES FcitxConfig.cmake FcitxMacro.cmake
  "${CMAKE_CURRENT_BINARY_DIR}/FcitxConfigVersion.cmake"
  DESTINATION "${prefix}/share/cmake/fcitx/")
install(FILES
  fcitx-merge-config.sh
  fcitx-cmake-helper.sh
  fcitx-extract-gettext.sh
  fcitx-extract-confdesc.sh
  fcitx-extract-desktop.sh
  fcitx-extract-po.sh
  fcitx-extract-qt.sh
  fcitx-extract-kde.sh
  DESTINATION "${prefix}/share/cmake/fcitx/"
  PERMISSIONS OWNER_READ OWNER_WRITE OWNER_EXECUTE
  GROUP_READ GROUP_EXECUTE WORLD_READ WORLD_EXECUTE)
install(FILES
  fcitx-parse-po.sh
  fcitx-write-po.sh
  DESTINATION "${prefix}/share/cmake/fcitx/"
  PERMISSIONS OWNER_READ OWNER_WRITE GROUP_READ WORLD_READ)

=== skin/CMakeLists.txt ===

foreach(skin default classic dark)
    add_subdirectory(${skin})
endforeach(skin default classic dark)

install(DIRECTORY imicon DESTINATION ${pkgdatadir}
            PATTERN .* EXCLUDE
            PATTERN *~ EXCLUDE)

=== skin/dark/CMakeLists.txt ===
file(GLOB SKIN_FILES *.png)

fcitx_translate_add_sources(
  fcitx_skin.conf.in)
fcitx_translate_add_apply_source(
  fcitx_skin.conf.in
  "${CMAKE_CURRENT_BINARY_DIR}/fcitx_skin.conf")

install(FILES ${SKIN_FILES} "${CMAKE_CURRENT_BINARY_DIR}/fcitx_skin.conf" DESTINATION ${pkgdatadir}/skin/dark)

=== skin/default/CMakeLists.txt ===
file(GLOB SKIN_FILES *.png)

fcitx_translate_add_sources(
  fcitx_skin.conf.in)
fcitx_translate_add_apply_source(
  fcitx_skin.conf.in
  "${CMAKE_CURRENT_BINARY_DIR}/fcitx_skin.conf")

install(FILES ${SKIN_FILES} "${CMAKE_CURRENT_BINARY_DIR}/fcitx_skin.conf" DESTINATION ${pkgdatadir}/skin/default)

=== src/frontend/ipcportal/CMakeLists.txt ===
set(FCITX_IPCPORTAL_LINK_LIBS)
if(_ENABLE_DBUS)
  include_directories(${DBUS_INCLUDE_DIRS})
  link_directories(${DBUS_LIBRARY_DIRS})
  pkg_check_modules(LibUUID "uuid" IMPORTED_TARGET REQUIRED)
  set(FCITX_IPCPORTAL_LINK_LIBS ${FCITX_IPCPORTAL_LINK_LIBS} ${DBUS_LIBRARIES} PkgConfig::LibUUID)
  set(ipcportal_noinstall)
else()
  set(ipcportal_noinstall NO_INSTALL)
endif()

set(FCITX_IPCPORTAL_SOURCES
  ipcportal.c
  )

fcitx_add_addon_full(ipcportal ${ipcportal_noinstall}
  SOURCES ${FCITX_IPCPORTAL_SOURCES}
  LINK_LIBS ${FCITX_IPCPORTAL_LINK_LIBS})

=== src/im/table/CMakeLists.txt ===
fcitx_translate_add_sources(
  data/qxm.conf.in
  data/wbx.conf.in
  data/wanfeng.conf.in
  data/db.conf.in
  data/wbpy.conf.in
  data/erbi.conf.in
  data/zrm.conf.in
  data/cangjie.conf.in
  )

set(FCITX_TABLE_SOURCES
  tabledict.c
  table.c
  tableconfig.c
  )
set(FCITX_TABLE_HEADERS
  tabledict.h
  table.h
  utf8_in_gb18030.h
  )
if(ENABLE_TABLE)
  set(table_noinstall)
  add_subdirectory(data)
else()
  set(table_noinstall NO_INSTALL)
endif()

fcitx_add_addon_full(table DESC ${table_noinstall}
  SOURCES ${FCITX_TABLE_SOURCES}
  EXTRA_DESC table.desc
  EXTRA_PO ${FCITX_TABLE_HEADERS})

=== src/lib/fcitx-gclient/CMakeLists.txt ===
set(FCITX_GCLIENT_SOURCES
  fcitxclient.c
  fcitxinputmethod.c
  fcitxkbd.c
  fcitxconnection.c
  )

set(FCITX_GCLIENT_BUILT_SOURCES
  ${CMAKE_CURRENT_BINARY_DIR}/marshall.c
  )

set(FCITX_GCLIENT_HEADERS
  fcitxclient.h
  fcitxinputmethod.h
  fcitxkbd.h
  fcitxconnection.h
  )

set(FCITX_GCLIENT_BUILT_HEADERS
  ${CMAKE_CURRENT_BINARY_DIR}/marshall.h
  )

fcitx_translate_add_sources(${FCITX_GCLIENT_SOURCES}
  ${FCITX_GCLIENT_HEADERS})

if(NOT (_ENABLE_DBUS AND ENABLE_GLIB2 AND GIO2_FOUND))
  return()
endif()

_pkgconfig_invoke("glib-2.0" GLIB2 GLIB_GENMARSHAL
  "" "--variable=glib_genmarshal")
FIND_PROGRAM(GLIB_GENMARSHAL ${GLIB2_GLIB_GENMARSHAL})

include_directories(${GIO2_INCLUDE_DIRS})
include_directories(${DBUS_INCLUDE_DIRS})
include_directories(${CMAKE_CURRENT_BINARY_DIR})
link_directories(${GIO2_LIBRARY_DIRS})
link_directories(${DBUS_LIBRARY_DIRS})

add_custom_command(OUTPUT marshall.c
  COMMAND ${GLIB_GENMARSHAL} --body --prefix=fcitx_marshall
  ${PROJECT_SOURCE_DIR}/src/frontend/gtk-common/marshall.list > marshall.c
  DEPENDS ${PROJECT_SOURCE_DIR}/src/frontend/gtk-common/marshall.list)
add_custom_command(OUTPUT marshall.h
  COMMAND ${GLIB_GENMARSHAL} --header --prefix=fcitx_marshall
  ${PROJECT_SOURCE_DIR}/src/frontend/gtk-common/marshall.list > marshall.h
  DEPENDS ${PROJECT_SOURCE_DIR}/src/frontend/gtk-common/marshall.list)

add_library(fcitx-gclient SHARED ${FCITX_GCLIENT_SOURCES}
  ${FCITX_GCLIENT_BUILT_SOURCES} ${FCITX_GCLIENT_BUILT_HEADERS})
set_target_properties(fcitx-gclient
  PROPERTIES VERSION 0.2
  SOVERSION 1
  COMPILE_FLAGS "-fvisibility=hidden"
  LINK_FLAGS "-Wl,--no-undefined")
target_link_libraries(fcitx-gclient ${GIO2_LIBRARIES}
  ${DBUS_LIBRARIES} fcitx-utils)
configure_file(fcitx-gclient.pc.in ${CMAKE_CURRENT_BINARY_DIR}/fcitx-gclient.pc)

install(TARGETS fcitx-gclient LIBRARY DESTINATION "${libdir}")
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/fcitx-gclient.pc
  DESTINATION "${pkgconfdir}")
install(FILES ${FCITX_GCLIENT_HEADERS}
  DESTINATION "${includedir}/fcitx-gclient")

if(ENABLE_GIR)
  include(GObjectIntrospection)
  gobject_introspection(
    FILENAME Fcitx-1.0.gir
    NSVERSION 1.0
    INCLUDE Gio-2.0 GObject-2.0 GLib-2.0
    PACKAGE_EXPORT fcitx-gclient
    LIBRARY fcitx-gclient
    SCANNER_ARGS --warn-all --add-include-path=${CMAKE_CURRENT_SOURCE_DIR}
    COMPILER_ARGS "--includedir=${CMAKE_CURRENT_SOURCE_DIR}"
    SYMBOL_PREFIXES fcitx
    SOURCES ${FCITX_GCLIENT_SOURCES} ${FCITX_GCLIENT_HEADERS}
    QUIET
    )
  install(FILES "${CMAKE_CURRENT_BINARY_DIR}/Fcitx-1.0.gir"
    DESTINATION "${GOBJECT_INTROSPECTION_GIRDIR}")
  install(FILES "${CMAKE_CURRENT_BINARY_DIR}/Fcitx-1.0.typelib"
    DESTINATION "${GOBJECT_INTROSPECTION_TYPELIBDIR}")
endif()

if(ENABLE_STATIC)
  add_library(fcitx-gclient-static STATIC ${FCITX_GCLIENT_SOURCES})
  set_target_properties(fcitx-gclient-static PROPERTIES
    OUTPUT_NAME "fcitx-gclient"
    PREFIX "lib")
  install(TARGETS fcitx-gclient-static
    LIBRARY DESTINATION "${libdir}"
    ARCHIVE DESTINATION "${libdir}")
endif()

add_subdirectory(test)

=== src/module/autoeng/CMakeLists.txt ===
set(FCITX_AUTOENG_SOURCES
  AutoEng.c)
fcitx_add_addon_full(autoeng DESC
  SOURCES ${FCITX_AUTOENG_SOURCES}
  EXTRA_PO AutoEng.h)

=== src/module/freedesktop-notify/CMakeLists.txt ===
if(_ENABLE_DBUS)
  include_directories(
    ${DBUS_INCLUDE_DIRS})
  link_directories(${DBUS_LIBRARY_DIRS})
else()
  set(freedesktop_notify_noinstall NO_INSTALL)
endif()

set(FCITX_FREEDESKTOP_NOTIFY_SOURCES
  freedesktop-notify.c
  )

fcitx_add_addon_full(freedesktop-notify ${freedesktop_notify_noinstall}
    SCAN SCAN_PRIV
    HEADERS freedesktop-notify.h
    SOURCES ${FCITX_FREEDESKTOP_NOTIFY_SOURCES}
    LINK_LIBS ${DBUS_LIBRARIES})

=== src/module/xkbdbus/CMakeLists.txt ===
set(FCITX_XKBDBUS_LINK_LIBS)
if(_ENABLE_XKBDBUS)
  include_directories(
    ${DBUS_INCLUDE_DIRS})
  set(FCITX_XKBDBUS_LINK_LIBS ${FCITX_XKBDBUS_LINK_LIBS}
    ${DBUS_LIBRARIES})
  link_directories(${DBUS_LIBRARY_DIRS})
  set(xkbdbus_noinstall)
else()
  set(xkbdbus_noinstall NO_INSTALL)
endif()

set(FCITX_XKBDBUS_SOURCES
  xkbdbus.c
  ../../im/keyboard/isocodes.c)
fcitx_add_addon_full(xkbdbus SCAN SCAN_PRIV ${xkbdbus_noinstall}
  SOURCES ${FCITX_XKBDBUS_SOURCES}
  LINK_LIBS ${FCITX_XKBDBUS_LINK_LIBS} PkgConfig::JsonC)

=== src/im/pinyin/data/CMakeLists.txt ===
set(FCITX_PY_FILES
  pySym.mb
  sp.dat
  )

set(PY_ORGDATA pyPhrase.org)
set(PY_DATA "${CMAKE_CURRENT_BINARY_DIR}/pybase.mb"
  "${CMAKE_CURRENT_BINARY_DIR}/pyphrase.mb")
set(PY_TAR pinyin.tar.gz)
set(PY_URL "http://download.fcitx-im.org/data/pinyin.tar.gz")

add_custom_target(pinyin_data ALL DEPENDS ${PY_DATA})

fcitx_download(py-data-download "${PY_URL}" "${PY_TAR}"
  MD5SUM 34dcb1b5209c28baa4e87f6a2773bfd0)
fcitx_extract(py-data-extract "${PY_TAR}" DEPENDS py-data-download
  OUTPUT ${PY_ORGDATA})
set(CREATE_PYMB_BIN "${PROJECT_BINARY_DIR}/tools/cli/createPYMB")
add_custom_command(OUTPUT ${PY_DATA}
  DEPENDS ${PY_ORGDATA} "${CREATE_PYMB_BIN}" py-data-extract
  COMMAND "${CREATE_PYMB_BIN}" "${CMAKE_CURRENT_SOURCE_DIR}/gbkpy.org"
  "${CMAKE_CURRENT_BINARY_DIR}/${PY_ORGDATA}")

install(FILES ${FCITX_PY_FILES} "${CMAKE_CURRENT_BINARY_DIR}/pybase.mb"
  "${CMAKE_CURRENT_BINARY_DIR}/pyphrase.mb" DESTINATION "${pkgdatadir}/pinyin")

set_directory_properties(PROPERTIES ADDITIONAL_MAKE_CLEAN_FILES
  "${CMAKE_CURRENT_BINARY_DIR}/pyERROR;${CMAKE_CURRENT_BINARY_DIR}/pyPhrase.ok")

=== debian/changelog ===
fcitx (1:4.2.9.9-2.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Build with lua5.1 by default. (Closes: #1099705)

 -- Bastian Germann <bage@debian.org>  Tue, 30 Sep 2025 10:59:26 +0200

fcitx (1:4.2.9.9-2) unstable; urgency=medium

  * Team upload.
  * debian/control: Indicate that package fcitx-table-cangjie was
    disabled by fcitx upstream since 2013, and this package shall
    not be used. (Closes: #898392)

 -- Boyuan Yang <byang@debian.org>  Mon, 18 Mar 2024 19:08:45 -0400

fcitx (1:4.2.9.9-1) unstable; urgency=medium

  * Team upload.
  * New upstream maintenance release.
  * debian/patches: Drop all backported patches.
  * debian/rules: Force non-parallel test.

 -- Boyuan Yang <byang@debian.org>  Tue, 26 Jul 2022 17:20:30 -0400

fcitx (1:4.2.9.8-8) unstable; urgency=medium

  * Team upload.
  * debian/rules: Pass -DCMAKE_BUILD_RPATH_USE_ORIGIN=ON via
  dh_auto_configure override for reproducibility. (Closes: #1001868)

 -- Boyuan Yang <byang@debian.org>  Sat, 28 May 2022 13:09:07 -0400

fcitx (1:4.2.9.8-7) unstable; urgency=medium

  * Team upload.

  [ Gunnar Hjalmarsson ]
  * Detach fcitx from Ubuntu’s language packs

 -- Boyuan Yang <byang@debian.org>  Mon, 18 Apr 2022 15:39:11 -0400

fcitx (1:4.2.9.8-6) unstable; urgency=medium

  * Team upload.
  * debian/control: Also let fcitx-frontend-all recommends
    fcitx-frontend-qt6.

 -- Boyuan Yang <byang@debian.org>  Mon, 18 Apr 2022 15:31:26 -0400

=== debian/control ===
# debian/control is generated automatically from control.in by running the clean target
Source: fcitx
Section: utils
Priority: optional
Maintainer: Debian Input Method Team <debian-input-method@lists.debian.org>
Uploaders: Aron Xu <aron@debian.org>, YunQiang Su <syq@debian.org>
Build-Depends: cmake,
               debhelper-compat (= 13),
               extra-cmake-modules,
               gobject-introspection,
               iso-codes,
               qtbase5-dev,
               libcairo2-dev (>= 1.0),
               libenchant-2-dev,
               libgettextpo-dev,
               libgirepository1.0-dev,
               libgtk-3-dev,
               libgtk2.0-dev,
               libicu-dev,
               libjson-c-dev,
               libkvm-dev [kfreebsd-any],
               liblua5.1-0-dev,
               libopencc-dev (>= 1.0.1),
               libpango1.0-dev (>= 1.0),
               libpresage-dev (>= 0.9.1-1.1~),
               libxkbfile-dev,
               libxkbcommon-dev (>= 0.5.0~),
               libxml2-dev,
               uuid-dev,
               x11proto-xinerama-dev,
Rules-Requires-Root: no
Standards-Version: 4.6.0
Homepage: https://github.com/fcitx/fcitx
Vcs-Git: https://salsa.debian.org/input-method-team/fcitx.git
Vcs-Browser: https://salsa.debian.org/input-method-team/fcitx

Package: fcitx
Architecture: all
Depends: fcitx-bin, fcitx-data, fcitx-modules, ${misc:Depends}
Recommends: fcitx-config-gtk | kde-config-fcitx,
            fcitx-frontend-all | fcitx-frontend-fbterm,
            fcitx-ui-classic | fcitx-ui-light,
            im-config (>= 0.5)
Suggests: fcitx-m17n, fcitx-tools
Conflicts: fcitx5
Description: Flexible Input Method Framework
 Fcitx is an input method framework with extension support, which provides
 an interface for entering characters of different scripts in applications
 using a variety of mapping systems.
 .
 It offers a pleasant and modern experience, with intuitive graphical
 configuration tools and customizable skins and mapping tables. It is
 highly modularized and extensible, with GTK+ 2/3 and Qt5 IM Modules, support
 for UIs based on Fbterm, pure Xlib, GTK+, or KDE, and a developer-friendly
 API.
 .
 This metapackage pulls in a set of components recommended for most desktop
 users.

Package: fcitx-bin
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Recommends: fcitx-data, fcitx-modules
Suggests: fcitx (>= ${source:Upstream-Version})
Replaces:
 fcitx (<< ${source:Upstream-Version}),
 fcitx-libs-dev (<< ${source:Version}),
Breaks:
 fcitx (<< ${source:Upstream-Version}),
 fcitx-libs-dev (<< ${source:Version}),
Conflicts:
 fcitx5,
Description: Flexible Input Method Framework - essential binaries
 Fcitx is an input method framework with extension support, which provides
 an interface for entering characters of different scripts in applications
 using a variety of mapping systems.
 .
 It offers a pleasant and modern experience, with intuitive graphical
 configuration tools and customizable skins and mapping tables. It is
 highly modularized and extensible, with GTK+ 2/3 and Qt5 IM Modules, support
 for UIs based on Fbterm, pure Xlib, GTK+, or KDE, and a developer-friendly
 API.
 .
 This package provides the essential executable binaries. If you are
 looking for a working input experience, please install the package
 "fcitx" instead.

Package: fcitx-data
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
Recommends: fcitx-bin
Suggests: fcitx (>= ${source:Upstream-Version})
Replaces: fcitx (<< ${source:Upstream-Version})
Breaks: fcitx (<< ${source:Upstream-Version})
Conflicts: fcitx5
Description: Flexible Input Method Framework - essential data files
 Fcitx is an input method framework with extension support, which provides
 an interface for entering characters of different scripts in applications
 using a variety of mapping systems.
 .
 It offers a pleasant and modern experience, with intuitive graphical
 configuration tools and customizable skins and mapping tables. It is
 highly modularized and extensible, with GTK+ 2/3 and Qt5 IM Modules, support
 for UIs based on Fbterm, pure Xlib, GTK+, or KDE, and a developer-friendly
 API.
 .
 This package provides the essential data files. If you are looking for a
 working input experience, please install the package "fcitx" instead.

Package: fcitx-libs
Architecture: all
Section: oldlibs
Depends: libfcitx-config4 (>= ${source:Version}),
         libfcitx-core0 (>= ${source:Version}),
         libfcitx-utils0 (>= ${source:Version}),
         libfcitx-gclient1 (>= ${source:Version}),
         ${misc:Depends}
Suggests: fcitx (>= ${source:Upstream-Version})
Replaces: fcitx (<< ${source:Upstream-Version})
Breaks: fcitx (<< ${source:Upstream-Version})
Description: Flexible Input Method Framework - metapackage for libraries
 Fcitx is an input method framework with extension support, which provides
 an interface for entering characters of different scripts in applications
 using a variety of mapping systems.
 .
 It offers a pleasant and modern experience, with intuitive graphical
 configuration tools and customizable skins and mapping tables. It is
 highly modularized and extensible, with GTK+ 2/3 and Qt5 IM Modules, support
 for UIs based on Fbterm, pure Xlib, GTK+, or KDE, and a developer-friendly
 API.
 .
 This package depends on all public libraries of fcitx.

Package: libfcitx-config4
Architecture: any
Section: libs
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends}, ${shlibs:Depends}
Suggests: fcitx (>= ${source:Upstream-Version})
Replaces: fcitx (<< ${source:Upstream-Version}), fcitx-libs (<< 1:4.2.8.5-3)
Breaks: fcitx (<< ${source:Upstream-Version}), fcitx-libs (<< 1:4.2.8.5-3)
Description: Flexible Input Method Framework - configuration support library
 Fcitx is an input method framework with extension support, which provides
 an interface for entering characters of different scripts in applications
 using a variety of mapping systems.
 .
 It offers a pleasant and modern experience, with intuitive graphical
 configuration tools and customizable skins and mapping tables. It is
 highly modularized and extensible, with GTK+ 2/3 and Qt5 IM Modules, support
 for UIs based on Fbterm, pure Xlib, GTK+, or KDE, and a developer-friendly
 API.
 .
 This package contains the library file:
  * libfcitx-config - support library for Fcitx configurations

Package: libfcitx-core0
Architecture: any
Section: libs
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends}, ${shlibs:Depends}
Suggests: fcitx (>= ${source:Upstream-Version})
Replaces: fcitx (<< ${source:Upstream-Version}), fcitx-libs (<< 1:4.2.8.5-3)
Breaks: fcitx (<< ${source:Upstream-Version}), fcitx-libs (<< 1:4.2.8.5-3)
Description: Flexible Input Method Framework - library of core functions
 Fcitx is an input method framework with extension support, which provides
 an interface for entering characters of different scripts in applications
 using a variety of mapping systems.
 .
 It offers a pleasant and modern experience, with intuitive graphical
 configuration tools and customizable skins and mapping tables. It is
 highly modularized and extensible, with GTK+ 2/3 and Qt5 IM Modules, support
 for UIs based on Fbterm, pure Xlib, GTK+, or KDE, and a developer-friendly
 API.
 .
 This package contains the library file:
  * libfcitx-core - core functions of Fcitx

Package: libfcitx-utils0
Architecture: any
Section: libs
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends}, ${shlibs:Depends}
Suggests: fcitx (>= ${source:Upstream-Version})
Replaces: fcitx (<< ${source:Upstream-Version}), fcitx-libs (<< 1:4.2.8.5-3)
Breaks: fcitx (<< ${source:Upstream-Version}), fcitx-libs (<< 1:4.2.8.5-3)
Description: Flexible Input Method Framework - utility support library
 Fcitx is an input method framework with extension support, which provides
 an interface for entering characters of different scripts in applications
 using a variety of mapping systems.
 .
 It offers a pleasant and modern experience, with intuitive graphical
 configuration tools and customizable skins and mapping tables. It is
 highly modularized and extensible, with GTK+ 2/3 and Qt5 IM Modules, support
 for UIs based on Fbterm, pure Xlib, GTK+, or KDE, and a developer-friendly
 API.
 .
 This package contains the library file:
  * libfcitx-utils - utility support library for Fcitx

Package: libfcitx-gclient1
Architecture: any
Section: libs
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends}, ${shlibs:Depends}
Suggests: fcitx (>= ${source:Upstream-Version})
Replaces: fcitx (<< ${source:Upstream-Version}),
          fcitx-libs-gclient (<< 1:4.2.8.5-3)
Breaks: fcitx (<< ${source:Upstream-Version}),
        fcitx-libs-gclient (<< 1:4.2.8.5-3)
Description: Flexible Input Method Framework - D-Bus client library for Glib
 Fcitx is an input method framework with extension support, which provides
 an interface for entering characters of different scripts in applications
 using a variety of mapping systems.
 .
 It offers a pleasant and modern experience, with intuitive graphical
 configuration tools and customizable skins and mapping tables. It is
 highly modularized and extensible, with GTK+ 2/3 and Qt5 IM Modules, support
 for UIs based on Fbterm, pure Xlib, GTK+, or KDE, and a developer-friendly
 API.
 .
 This package contains the following library:
  * libfcitx-gclient - D-Bus client library for Glib

Package: fcitx-libs-dev
Architecture: any
Section: libdevel
Depends: fcitx-bin (>= ${source:Version}),
         gir1.2-fcitx-1.0 (= ${binary:Version}),
         libfcitx-config4 (= ${binary:Version}),
         libfcitx-core0 (= ${binary:Version}),
         libfcitx-gclient1 (= ${binary:Version}),
         libfcitx-utils0 (= ${binary:Version}),
         ${misc:Depends}
Replaces: fcitx (<< ${source:Upstream-Version})
Breaks: fcitx (<< ${source:Upstream-Version})
Description: Flexible Input Method Framework - library development files
 Fcitx is an input method framework with extension support, which provides
 an interface for entering characters of different scripts in applications
 using a variety of mapping systems.
 .
 It offers a pleasant and modern experience, with intuitive graphical
 configuration tools and customizable skins and mapping tables. It is
 highly modularized and extensible, with GTK+ 2/3 and Qt5 IM Modules, support
 for UIs based on Fbterm, pure Xlib, GTK+, or KDE, and a developer-friendly
 API.
 .
 This package provides the library development files.

Package: gir1.2-fcitx-1.0
Architecture: any
Section: introspection
Depends: ${gir:Depends}, ${misc:Depends}
Suggests: fcitx (>= ${source:Upstream-Version})
Replaces: fcitx (<< ${source:Upstream-Version})
Breaks: fcitx (<< ${source:Upstream-Version})
Description: GObject introspection data for fcitx
 Fcitx is an input method framework with extension support, which provides
 an interface for entering characters of different scripts in applications
 using a variety of mapping systems.
 .
 It offers a pleasant and modern experience, with intuitive graphical
 configuration tools and customizable skins and mapping tables. It is
 highly modularized and extensible, with GTK+ 2/3 and Qt5 IM Modules, support
 for UIs based on Fbterm, pure Xlib, GTK+, or KDE, and a developer-friendly
 API.
 .
 This package can be used by other packages using the GIRepository format to
 generate dynamic bindings.

Package: fcitx-ui-classic
Architecture: any
Depends: fcitx-module-x11, ${misc:Depends}, ${shlibs:Depends}
Recommends: fcitx (>= ${source:Upstream-Version}), zenity | kdialog
Replaces: fcitx (<< ${source:Upstream-Version}),
          fcitx-hangul (<< 0.3.0),
          fcitx-unikey (<< 0.2.0)
Breaks: fcitx (<< ${source:Upstream-Version}),
        fcitx-hangul (<< 0.3.0),
        fcitx-unikey (<< 0.2.0)
Description: Flexible Input Method Framework - Classic user interface
 Fcitx is an input method framework with extension support, which provides

=== debian/rules ===
#!/usr/bin/make -f

include debian/variables.mk
include debian/gencontrol.mk

%:
	dh $@ --with gir

override_dh_auto_clean: gen_control
	dh_auto_clean

override_dh_auto_configure: gen_control
	dh_auto_configure -- \
	    -DCMAKE_BUILD_RPATH_USE_ORIGIN=ON \
	    -DCMAKE_BUILD_TYPE=Release \
	    -DLIB_INSTALL_DIR=/usr/lib/$(DEB_HOST_MULTIARCH) \
	    -DSYSCONFDIR=/etc \
	    -DENABLE_X11=ON \
	    -DENABLE_GLIB2=ON \
	    -DENABLE_CAIRO=ON \
	    -DENABLE_DBUS=ON \
	    -DENABLE_PANGO=ON \
	    -DENABLE_XKB=ON \
	    -DENABLE_DEBUG=OFF \
	    -DENABLE_PINYIN=ON \
	    -DENABLE_TABLE=ON \
	    -DENABLE_GTK2_IM_MODULE=ON \
	    -DENABLE_GTK3_IM_MODULE=ON \
	    -DENABLE_QT=OFF \
	    -DENABLE_LUA=ON \
	    -DENABLE_STATIC=OFF \
	    -DENABLE_TEST=ON \
	    -DENABLE_SNOOPER=ON \
	    -DENABLE_GIR=ON \
	    -DENABLE_ENCHANT=ON \
	    -DENABLE_PRESAGE=ON \
	    -DENABLE_ICU=ON \
	    -DENABLE_BACKTRACE=ON \
	    -DENABLE_XDGAUTOSTART=ON \
	    -DENABLE_GETTEXT=ON

override_dh_makeshlibs:
	dh_makeshlibs -plibfcitx-core0
	dh_makeshlibs -plibfcitx-config4
	dh_makeshlibs -plibfcitx-utils0
	dh_makeshlibs -plibfcitx-gclient1

override_dh_auto_test:
	dh_auto_test --no-parallel

=== debian/watch ===
version=4
opts="pgpmode=auto" \
 https://download.fcitx-im.org/fcitx/ fcitx-([0-9]\.*.*)_dict\.tar\.xz debian uupdate

## fcitx 4.2.9.9%2Bmint1%2Bfaye

=== debian/changelog ===
fcitx (1:4.2.9.9+mint1+faye) faye; urgency=medium

  * Native source format
  * Tray icon: Use fcitx-kbd-symbolic instead of input-keyboard

 -- Clement Lefebvre <root@linuxmint.com>  Wed, 23 Aug 2023 12:22:49 +0100

## fcitx 4.2.9.9+mint1+gigi

=== CMakeLists.txt ===
--- 
+++ 
@@ -213,12 +213,6 @@
 
 list(FIND CMAKE_PLATFORM_IMPLICIT_LINK_DIRECTORIES "${LIB_INSTALL_DIR}" _isSystemPlatformLibDir)
 list(FIND CMAKE_CXX_IMPLICIT_LINK_DIRECTORIES "${LIB_INSTALL_DIR}" _isSystemCxxLibDir)
-if("${_isSystemPlatformLibDir}" STREQUAL "-1" AND "${_isSystemCxxLibDir}" STREQUAL "-1")
-    set(CMAKE_SKIP_BUILD_RPATH  FALSE)
-    set(CMAKE_BUILD_WITH_INSTALL_RPATH FALSE)
-    set(CMAKE_INSTALL_RPATH "${LIB_INSTALL_DIR}")
-    set(CMAKE_INSTALL_RPATH_USE_LINK_PATH TRUE)
-endif("${_isSystemPlatformLibDir}" STREQUAL "-1" AND "${_isSystemCxxLibDir}" STREQUAL "-1")
 
 # For FcitxMacro
 set(FCITX4_ADDON_INSTALL_DIR ${addondir})

=== src/lib/CMakeLists.txt ===
add_subdirectory(fcitx-config)
add_subdirectory(fcitx-utils)
add_subdirectory(fcitx)
if(_ENABLE_DBUS AND ENABLE_GLIB2)
  PKG_CHECK_MODULES(GIO2 "gio-2.0>=2.26")
endif()
add_subdirectory(fcitx-gclient)
if (ENABLE_QT)
add_subdirectory(fcitx-qt)
endif (ENABLE_QT)

=== tools/dev/CMakeLists.txt ===
set(fcitx_scanner_SOURCES
  fcitx-scanner.c
  )

add_executable(fcitx-scanner ${fcitx_scanner_SOURCES})
target_link_libraries(fcitx-scanner fcitx-utils)

set(fcitx_po_parser_SOURCES
  fcitx-po-parser.c
  )

if(NOT _FCITX_DISABLE_GETTEXT)
  include_directories(${GETTEXTPO_INCLUDE_DIR})
endif()

add_executable(fcitx-po-parser ${fcitx_po_parser_SOURCES})

if(NOT _FCITX_DISABLE_GETTEXT)
  target_link_libraries(fcitx-po-parser fcitx-utils ${GETTEXTPO_LIBRARIES})
endif()

install(TARGETS fcitx-scanner fcitx-po-parser
  DESTINATION "${addondir}/libexec")

=== debian/changelog ===
fcitx (1:4.2.9.9+mint1+gigi) wilma; urgency=medium

  * Native source format
  * Tray icon: Use fcitx-kbd-symbolic instead of input-keyboard

 -- Clement Lefebvre <root@linuxmint.com>  Sun, 16 Jun 2024 14:44:11 +0100

fcitx (1:4.2.9.9-2build2) noble; urgency=high

  * No change rebuild against libglib2.0-0t64.

 -- Julian Andres Klode <juliank@ubuntu.com>  Mon, 08 Apr 2024 16:38:44 +0200

fcitx (1:4.2.9.9-2build1) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sun, 31 Mar 2024 00:06:45 +0000

## fcitx 4.2.9.9+mint1+wilma

=== debian/changelog ===
fcitx (1:4.2.9.9+mint1+wilma) wilma; urgency=medium

  * Native source format
  * Tray icon: Use fcitx-kbd-symbolic instead of input-keyboard

 -- Clement Lefebvre <root@linuxmint.com>  Sun, 16 Jun 2024 14:44:11 +0100
